<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author: Digvijay Singh
 * @copyright: ADG Online Solutions
 * @date: 08-11-2019
 * @desc: Balanced Scorecard Approach For CGWB 
 */
class Stackholder extends Admin_Controller
{

    public function __construct()
    {
        ini_set('display_errors', 1);
        parent::__construct();
        $this->load->library('form_validation');
        $this->load->model('Stackholder_model');
        $this->load->model('Capacity_building_model');
        $this->load->model('Disposal_noc_model');
        $this->load->model('Disposal_model');
        $this->load->model('Share_info_model');
        $this->load->model('Technical_model');
        $this->load->helper('ckeditor');
        $this->data['ckeditor'] = array(
            'id' => 'ck_editor',
            'path' => 'asset/js/ckeditor',
            'config' => array(
                'toolbar' => "Full",
                'width' => "99.8%",
                'height' => "400px"
            )
        );
    }
    public function short_term_investigation($id = NULL, $opt_id = NULL)
    {
        $data['active']=1;
        
        if($this->input->post('submit'))
        {
            
            $this->form_validation->set_rules('Target', 'Target', 'required');
            $this->form_validation->set_rules('expenditure', 'expenditure', 'required');
            $this->form_validation->set_rules('progressive', 'progressive', 'required');
            $this->form_validation->set_rules('achivement', 'achivement', 'required');
            $S_id=$this->input->post('id');
            $created_at = date("Y-m-d"); 
            if ($this->form_validation->run() == true)
           {
            if(isset($S_id) && !empty($S_id))
            {
                $all=array(
                            'total_target'=>$this->input->post('Target'),
                            'expenditure_during'=>$this->input->post('expenditure'),
                            'progressive'=>$this->input->post('progressive'),
                            'achivment'=>$this->input->post('achivement'),
                            'region'=>$this->input->post('region'),
                            'month'=>$this->input->post('month'),
                            'year'=>$this->input->post('year'),
                            'state_id'=>$this->input->post('state'),
                            'modify'=>$created_at,
                         );
                $this->Stackholder_model->update_data($all,$S_id);
            }   
            else{
                 $all=array(
                           'total_target'=>$this->input->post('Target'),
                           'expenditure_during'=>$this->input->post('expenditure'),
                           'progressive'=>$this->input->post('progressive'),
                           'achivment'=>$this->input->post('achivement'),
                           'region'=>$this->input->post('region'),
                           'month'=>$this->input->post('month'),
                           'year'=>$this->input->post('year'),
                           'state_id'=>$this->input->post('state'),
                           'created_on'=>$created_at,
                    );
                      $this->Stackholder_model->insert_data($all);
                }  
            }
            }
           if($id)
            {
              
               $data['active']=2;
               /* get edit data model*/
               $data['edit_data']=$this->Stackholder_model->edit_data($id);
            }
           $this->Stackholder_model->_table_name = 'tbl_region';
           $this->Stackholder_model->_primary_key = '';
           $this->Stackholder_model->_order_by="id";
           $data['state']=$this->Stackholder_model->state_data();
           $data['main']=$this->Stackholder_model->region_data();
           $data['stack_data']=$this->Stackholder_model->all_data();
           ////////////////*view*/////////////////////
           $data['subview'] = $this->load->view('admin/Stackholder/Investigation', $data, TRUE);
           $this->load->view('admin/_layout_main', $data);
      }
              ////////////////delete data///////////////
                public function delete_data($id)
        {
        
              $status=0;
              $this->Stackholder_model->delete_data($status,$id);
              redirect(base_url('admin/Stackholder/short_term_investigation'));
        }
   
    public function capacity_building($id = NULL, $opt_id = NULL)
    {
          
        $data['active']=1;
        
        if($this->input->post('submit'))
        {
          
            $this->form_validation->set_rules('target', 'Target', 'required');
            $this->form_validation->set_rules('achivement', 'expenditure', 'required');
            $this->form_validation->set_rules('process', 'progressive', 'required');
            $this->form_validation->set_rules('against', 'achivement', 'required');
            $S_id=$this->input->post('id');
            $created_at = date("Y-m-d"); 
            if ($this->form_validation->run() == true)
           {
            if(isset($S_id) && !empty($S_id))
            {
                $all=array(
                            'total_target'=>$this->input->post('target'),
                            'achievement_during'=>$this->input->post('achivement'),
                            'progressive_achievement'=>$this->input->post('process'),
                            'achievement_against_target'=>$this->input->post('against'),
                             'region'=>$this->input->post('region'),
                             'month'=>$this->input->post('month'),
                             'year'=>$this->input->post('year'),
                             'state_id'=>$this->input->post('state'),
                             'modify'=>$created_at,
                         );
                         
                      $this->Capacity_building_model->update_data($all,$S_id);
            }   
            else{
                 $all=array(
                     'total_target'=>$this->input->post('target'),
                     'achievement_during'=>$this->input->post('achivement'),
                     'progressive_achievement'=>$this->input->post('process'),
                     'achievement_against_target'=>$this->input->post('against'),
                     'region'=>$this->input->post('region'),
                     'month'=>$this->input->post('month'),
                    'year'=>$this->input->post('year'),
                    'state_id'=>$this->input->post('state'),
                    'created_on'=>$created_at,
                 );
                      $this->Capacity_building_model->insert_data($all);
                }  
            }
            }
           if($id)
            {
              
               $data['active']=2;
               /* get edit data model*/
               $data['edit_data']=$this->Capacity_building_model->edit_data($id);
            }
            $data['state']=$this->Stackholder_model->state_data();
           $data['main']=$this->Capacity_building_model->region_data();
           //print_r($data['main']);die;
           $data['stack_data']=$this->Capacity_building_model->all_data();
           ////////////////*view*/////////////////////
           $data['subview'] = $this->load->view('Capacity_building', $data, TRUE);
           $this->load->view('admin/_layout_main', $data);

    }
    public function delete_data_capacity($id)
    {
    
          $status=0;
          $this->Capacity_building_model->delete_data($status,$id);
          redirect(base_url('admin/Stackholder/capacity_building'));
    }
    public function disposal_of_noc($id = NULL, $opt_id = NULL)
    {
        $data['active']=1;
        
        if($this->input->post('submit'))
        {
            
            $this->form_validation->set_rules('balance', 'Target', 'required');
            $this->form_validation->set_rules('app', 'expenditure', 'required');
            $this->form_validation->set_rules('process', 'progressive', 'required');
            $this->form_validation->set_rules('achivement', 'achivement', 'required');
            $S_id=$this->input->post('id');
            $created_at = date("Y-m-d");
            if ($this->form_validation->run() == true)
           {
            if(isset($S_id) && !empty($S_id))
            {
                $all=array(
                            'balance_number'=>$this->input->post('balance'),
                            'application_recived_current'=>$this->input->post('app'),
                            'process_case_curr_year'=>$this->input->post('process'),
                            'achivment'=>$this->input->post('achivement'),
                            'region'=>$this->input->post('region'),
                            'month'=>$this->input->post('month'),
                            'year'=>$this->input->post('year'),
                            'state_id'=>$this->input->post('state'),
                            'modify'=>$created_at,
                         );
                      $this->Disposal_noc_model->update_data($all,$S_id);
            }   
            else{
                 $all=array(
                    'balance_number'=>$this->input->post('balance'),
                    'application_recived_current'=>$this->input->post('app'),
                    'process_case_curr_year'=>$this->input->post('process'),
                    'achivment'=>$this->input->post('achivement'),
                    'region'=>$this->input->post('region'),
                    'month'=>$this->input->post('month'),
                    'year'=>$this->input->post('year'),
                    'state_id'=>$this->input->post('state'),
                    'created_on'=>$created_at,
                 );
                      $this->Disposal_noc_model->insert_data($all);
                }  
            }
            }
           if($id)
            {
              
               $data['active']=2;
               /* get edit data model*/
               $data['edit_data']=$this->Disposal_noc_model->edit_data($id);
            }
      
           $data['state']=$this->Stackholder_model->state_data();
           $data['main']=$this->Disposal_noc_model->region_data();
           $data['stack_data']=$this->Disposal_noc_model->all_data();
           ////////////////*view*/////////////////////
           $data['subview'] = $this->load->view('admin/Stackholder/Disposal_noc', $data, TRUE);
           $this->load->view('admin/_layout_main', $data);
    }
    public function delete_data_noc($id)
    {
    
          $status=0;
          $this->Disposal_noc_model->delete_data($status,$id);
          redirect(base_url('admin/Stackholder/disposal_of_noc'));
    }
    public function disposal_cases($id = NULL, $opt_id = NULL)
    {
       
        $data['active']=1;
        
        if($this->input->post('submit'))
        {
            
            $this->form_validation->set_rules('balance', 'Target', 'required');
            $this->form_validation->set_rules('case', 'expenditure', 'required');
            $this->form_validation->set_rules('address', 'progressive', 'required');
            $this->form_validation->set_rules('achivement', 'achivement', 'required');
            $S_id=$this->input->post('id');
            $created_at = date("Y-m-d");
            if ($this->form_validation->run() == true)
           {
            if(isset($S_id) && !empty($S_id))
            {     
                $all=array(
                            'balance_number'=>$this->input->post('balance'),
                            'number_case'=>$this->input->post('case'),
                            'number_case_address'=>$this->input->post('address'),
                            'achivment'=>$this->input->post('achivement'),
                            'region'=>$this->input->post('region'),
                            'month'=>$this->input->post('month'),
                            'year'=>$this->input->post('year'),
                            'state_id'=>$this->input->post('state'),
                            'modify'=>$created_at,

                         );
                        
                          $this->Disposal_model->update_data($all,$S_id);
            }   
            else{
                 $all=array(
                    'balance_number'=>$this->input->post('balance'),
                    'number_case'=>$this->input->post('case'),
                    'number_case_address'=>$this->input->post('address'),
                    'achivment'=>$this->input->post('achivement'),
                    'region'=>$this->input->post('region'),
                    'month'=>$this->input->post('month'),
                    'year'=>$this->input->post('year'),
                    'state_id'=>$this->input->post('state'),
                    'created_on'=>$created_at,
                 );
                      $this->Disposal_model->insert_data($all);
                }  
            }
            }
           if($id)
            {
              
               $data['active']=2;
               /* get edit data model*/
               $data['edit_data']=$this->Disposal_model->edit_data($id);
              // print_r( $data['edit_data']);die;
            }
            $data['state']=$this->Stackholder_model->state_data();
           $data['main']=$this->Disposal_model->region_data();
           $data['stack_data']=$this->Disposal_model->all_data();
           ////////////////*view*/////////////////////
           $data['subview'] = $this->load->view('admin/Stackholder/Disposal_case', $data, TRUE);
           $this->load->view('admin/_layout_main', $data);
    }
    public function delete_data_disposal1($id)
    {
    
          $status=0;
          $this->Disposal_model->delete_data($status,$id);
          redirect(base_url('admin/Stackholder/disposal_cases'));
    }

    public function technical_support($id = NULL, $opt_id = NULL)
    {
        
        $data['active']=1;
        
        if($this->input->post('submit'))
        {
            
            $this->form_validation->set_rules('balance', 'Target', 'required');
            $this->form_validation->set_rules('case', 'expenditure', 'required');
            $this->form_validation->set_rules('address', 'progressive', 'required');
            $this->form_validation->set_rules('achivement', 'achivement', 'required');
            $S_id=$this->input->post('id');
            $created_at = date("Y-m-d");
            $created_at = date("Y-m-d");
            if ($this->form_validation->run() == true)
           {
            if(isset($S_id) && !empty($S_id))
            {
                $all=array(
                            'balance_number'=>$this->input->post('balance'),
                            'num_cases'=>$this->input->post('case'),
                            'num_case_address'=>$this->input->post('address'),
                            'achievement'=>$this->input->post('achivement'),
                            'region'=>$this->input->post('region'),
                            'month'=>$this->input->post('month'),
                             'year'=>$this->input->post('year'),
                             'state_id'=>$this->input->post('state'),
                             'modify'=>$created_at,

                         );
                      $this->Technical_model->update_data($all,$S_id);
            }   
            else{
                 $all=array(
                    'balance_number'=>$this->input->post('balance'),
                    'num_cases'=>$this->input->post('case'),
                    'num_case_address'=>$this->input->post('address'),
                    'achievement'=>$this->input->post('achivement'),
                    'region'=>$this->input->post('region'),
                    'month'=>$this->input->post('month'),
                    'year'=>$this->input->post('year'),
                    'state_id'=>$this->input->post('state'),
                    'created_on'=>$created_at,
                 );
                      $this->Technical_model->insert_data($all);
                }  
            }
            }
           if($id)
            {
              
               $data['active']=2;
               /* get edit data model*/
               $data['edit_data']=$this->Technical_model->edit_data($id);
            }
            $data['state']=$this->Stackholder_model->state_data();
           $data['main']=$this->Technical_model->region_data();
           $data['stack_data']=$this->Technical_model->all_data();
           ////////////////*view*/////////////////////
           $data['subview'] = $this->load->view('admin/Stackholder/Technical', $data, TRUE);
           $this->load->view('admin/_layout_main', $data);
    }
    public function delete_data_technical($id)
    {
    
          $status=0;
          $this->Technical_model->delete_data($status,$id);
          redirect(base_url('admin/Stackholder/technical_support'));
    }
    public function sharing_of_info($id = NULL, $opt_id = NULL)
    {
        
        
        $data['active']=1;
        
        if($this->input->post('submit'))
        {
            
            $this->form_validation->set_rules('balance', 'Target', 'required');
            $this->form_validation->set_rules('target', 'expenditure', 'required');
            $this->form_validation->set_rules('map', 'progressive', 'required');
            $this->form_validation->set_rules('achivement', 'achivement', 'required');
            $S_id=$this->input->post('id');
            $created_at = date("Y-m-d");
             
            if ($this->form_validation->run() == true)
           {
            if(isset($S_id) && !empty($S_id))
            {
                $all=array(
                            'balance'=>$this->input->post('balance'),
                            'target'=>$this->input->post('target'),
                            'map'=>$this->input->post('map'),
                            'achievement'=>$this->input->post('achivement'),
                            'region'=>$this->input->post('region'),
                            'month'=>$this->input->post('month'),
                            'year'=>$this->input->post('year'),
                            'state_id'=>$this->input->post('state'),
                            'modify'=>$created_at,

                         );
                      $this->Share_info_model->update_data($all,$S_id);
            }   
            else{
                 $all=array(
                    'balance'=>$this->input->post('balance'),
                    'target'=>$this->input->post('target'),
                    'map'=>$this->input->post('map'),
                    'achievement'=>$this->input->post('achivement'),
                    'region'=>$this->input->post('region'),
                    'month'=>$this->input->post('month'),
                    'year'=>$this->input->post('year'),
                    'state_id'=>$this->input->post('state'),
                    'created_on'=>$created_at,
                 );
                    //print_r($all);die;
                      $this->Share_info_model->insert_data($all);
                }  
            }
            }
           if($id)
            {
              
               $data['active']=2;
               /* get edit data model*/
               $data['edit_data']=$this->Share_info_model->edit_data($id);
            }
           $data['state']=$this->Stackholder_model->state_data();
           $data['main']=$this->Share_info_model->region_data();
           $data['stack_data']=$this->Share_info_model->all_data();
           ////////////////*view*/////////////////////
           $data['subview'] = $this->load->view('admin/Stackholder/Share_info', $data, TRUE);
           $this->load->view('admin/_layout_main', $data);

    }
    public function delete_data_share($id)
    {
    
          $status=0;
          $this->Share_info_model->delete_data($status,$id);
          redirect(base_url('admin/Stackholder/sharing_of_info'));
    }
    
    
   

    
}