<?php class Document_Model extends MY_Model{

    public $_table_name;
    public $_order_by;
    public $_primary_key;
    

    function create_folder_data(){

        $this->db->select('path');
        $pathQuery = $this->db->get_where('tbl_dms_document_details',['id' => $this->input->post('parent_folder') ]);
        if($pathQuery->num_rows() > 0){
           $path =  $pathQuery->row_array()['path'];
           $filepath = $path.'/'.$this->input->post('folder_name');
        }else{
           $filepath = '/'.$this->input->post('folder_name');
        }

        $hashString = $this->hash(md5(time('H:i:s'))); 

        $folderData = [ 'root_id' => $this->session->userdata('root_id'),
                        'token' => $hashString,
                        'name' => $this->input->post('folder_name'),
                        'title' => $this->input->post('folder_name'),
                        'original_name' => $this->input->post('folder_name'),
                        'parent' => $this->input->post('parent_folder'),
                        'path' => $filepath,
                        'created_on' => date('Y-m-d h:i:s'),
                        'filepath' => '',
                        'fullfilepath' => '',
                        'extension' => '',
                        'size' => '',
                        'mime_type' => ''
                      ];
        $this->db->insert('tbl_dms_document_details', $folderData);
        if($this->db->affected_rows()){
            $this->db->insert('tbl_dms_document', [ 'token' => $hashString ,'version_id' => $this->db->insert_id() ]);
            if($this->db->affected_rows()){ 
                return true;    
            }else{
                return false;
            }                    
        }
    }




    function uploadFileAndFolderData($filedata){
        
        $hashString = $this->hash(md5(time('H:i:s'))); 
        $expData = explode(".", $filedata['original_name']);
        $fileNfolderData = [ 'root_id' => $this->session->userdata('root_id'),
                             'token' => $hashString,
                             'name' => $filedata['fileName'],
                             'title' => $expData[0],
                             'original_name' => $filedata['original_name'],
                             'parent' => $this->input->post('parent_folder'),
                             'language' => $this->input->post('language'),
                             'path' => '/'.$filedata['fileName'],
                             'created_on' => date('Y-m-d h:i:s'),
                             'filepath' => $filedata['fileName'],
                             'fullfilepath' => $filedata['fullPath'],
                             'extension' => $filedata['ext'],
                             'size' => $filedata['size'],
                             'version' => 1.0,
                             'file_json' => json_encode(array('0' => $filedata)),
                             'mime_type' => $filedata['mime_type'],
                            ];


        
             $this->db->insert('tbl_dms_document_details', $fileNfolderData);
             if($this->db->affected_rows()){
                    $this->db->insert('tbl_dms_document', [ 'token' => $hashString, 'version_id' => $this->db->insert_id() ]);                    
                    
                    $vhashString = $this->hash(md5(time('H:i:s'))); 
                    $data = [ 'v_file_token' => $vhashString,
                             'v_file_name' => $filedata['fileName'],
                             'doc_details_id' => $this->db->insert_id(),
                             'v_author' => $this->session->userdata('user_id'),
                             'v_path' => '/'.$filedata['fileName'],
                             'created_on' => date('Y-m-d h:i:s'),
                             'v_file_path' => $filedata['path'],
                             'v_file_fullpath' => $filedata['fullPath'],
                             'v_file_ext' => $filedata['ext'],
                             'v_size' => $filedata['size'],
                             'v_file_json' => json_encode(array('0' => $filedata)),
                             'v_mime_type' => $filedata['mime_type'],
                           ];
                    $this->db->insert('tbl_dms_version_file', $data); 
                }
    }

    function uploadFileAndFolderVersion($filedata){

                            $fileNfolderData = [ 
                                    'path' => '/'.$filedata['fileName'],
                                    'updated_on' => date('Y-m-d h:i:s'),
                                    'filepath' => $filedata['path'],
                                    'fullfilepath' => $filedata['fullPath'],
                                    'updated_by' => $this->session->userdata('user_id'),
                                    'extension' => $filedata['ext'],
                                    'size' => $filedata['size'],
                                    'file_json' => json_encode(array('0' => $filedata)),
                                    'mime_type' => $filedata['mime_type'],
                            ];
                            $this->db->where('token', $filedata['doc_token']);
                            $this->db->update('tbl_dms_document_details', $fileNfolderData);


                            if($this->db->affected_rows()){
                                $vhashString = $this->hash(md5(time('H:i:s'))); 
                                $data = [   'v_file_token' => $vhashString,
                                            'v_file_name' => $filedata['fileName'],
                                            'doc_details_id' => $filedata['doc_id'],
                                            'v_author' => $this->session->userdata('user_id'),
                                            'v_path' => '/'.$filedata['fileName'],
                                            'created_on' => date('Y-m-d h:i:s'),
                                            'v_file_path' => $filedata['path'],
                                            'v_file_fullpath' => $filedata['fullPath'],
                                            'v_file_ext' => $filedata['ext'],
                                            'v_size' => $filedata['size'],
                                            'v_file_json' => json_encode(array('0' => $filedata)),
                                            'v_mime_type' => $filedata['mime_type'],
                                    ];
                                $this->db->insert('tbl_dms_version_file', $data);                    
                            }
    }



    function getTokenRelatedFileFolderData($token){
         $this->db->select('tdd.root_id,tdd.id as id,tdd.name as name, tdd.updated_on,tdd.id as dms_doc_id, tdd.original_name,tdd.title,tdd.version,tdd.size,tdd.language,tdd.extension,tdd.mime_type');
         $this->db->where('tdd.parent', $token);
         $this->db->where('tdd.is_my_document ', 0 );
        // $this->db->where('tdd.root_id' ,$this->session->userdata('root_id'));
         $this->db->from('tbl_dms_document as td');
         $this->db->join('tbl_dms_document_details as tdd','td.version_id = tdd.id');
         $tokenQuery = $this->db->get();
         //echo $this->db->last_query();
         if($tokenQuery->num_rows() > 0){
             return $tokenQuery->result_array();
         }
    }


    function getMyDocumentChildListing($token = 0){
        $this->db->select('tdd.root_id,tdd.id as id,tdd.name as name, tdd.updated_on,tdd.id as dms_doc_id,tdd.original_name,tdd.title,tdd.version,tdd.size,tdd.language,tdd.extension,tdd.mime_type');
        $this->db->where('tdd.parent', $token);
        $this->db->where('tdd.is_my_document ', 1 );
        //$this->db->where('tdd.root_id' ,$this->session->userdata('root_id'));
        $this->db->from('tbl_dms_document as td');
        $this->db->join('tbl_dms_document_details as tdd','td.version_id = tdd.id');
        $tokenQuery = $this->db->get();
        //echo $this->db->last_query();
        if($tokenQuery->num_rows() > 0){
            return $tokenQuery->result_array();
        }
   }



    function getRelatedFileFolderPropertiesData($token){
        if($token == ''){
                 $this->db->where('user_id' ,$this->session->userdata('user_id'));
                 $tokenQuery = $this->db->get('tbl_dms_root');
                 if($tokenQuery->num_rows() > 0){
                    $rootData = $tokenQuery->row_array();
                    return [ 'document_id' => $rootData['id'], 'id' => $rootData['id'], 'token' => $rootData['root_token'], 'name' => 'root', 'created_on' => $rootData['created_on'],'user' => $this->session->userdata('name')   ];
                 }
        }else{
            $this->db->select('tdd.id as id, tdd.token as token,tdd.name as name, tdd.created_on as created_on,tdd.original_name');
            $this->db->where('tdd.id', $token);
            //$this->db->where('tdd.root_id' ,$this->session->userdata('root_id'));
            $this->db->join('tbl_dms_document_details as tdd','td.version_id = tdd.id');
            $this->db->from('tbl_dms_document as td');
            $tokenQuery = $this->db->get();
                if($tokenQuery->num_rows() > 0){
                  $ffData = $tokenQuery->row_array();
                  return [ 'document_id' => $ffData['id'], 'id' => $ffData['id'], 'token' => $ffData['token'], 'name' => $ffData['original_name'], 'created_on' => $ffData['created_on'], 'user' => $this->session->userdata('name') ];
                }
        }


    }



    function getMyDocumentProperty($token){
        if($token == ''){
                 $this->db->where('user_id' ,$this->session->userdata('user_id'));
                 $tokenQuery = $this->db->get('tbl_dms_root');
                 if($tokenQuery->num_rows() > 0){
                    $rootData = $tokenQuery->row_array();
                    return [ 'document_id' => $rootData['id'], 'id' => $rootData['id'], 'token' => $rootData['root_token'], 'name' => 'root', 'created_on' => $rootData['created_on'],'user' => $this->session->userdata('name')   ];
                 }
        }else{
            $this->db->select('tdd.id as id, tdd.token as token,tdd.name as name, tdd.created_on as created_on');
            $this->db->where('tdd.id', $token);
            //$this->db->where('tdd.root_id' ,$this->session->userdata('root_id'));
            $this->db->join('tbl_dms_document_details as tdd','td.version_id = tdd.id');
            $this->db->from('tbl_dms_document as td');
            $tokenQuery = $this->db->get();
                if($tokenQuery->num_rows() > 0){
                  $ffData = $tokenQuery->row_array();
                  return [ 'document_id' => $ffData['id'], 'id' => $ffData['id'], 'token' => $ffData['token'], 'name' => $ffData['name'], 'created_on' => $ffData['created_on'], 'user' => $this->session->userdata('name') ];
                }
        }


    }



    function getParentFolderData(){
        
          $this->db->select('*, tdd.name as docname');
          $this->db->from('tbl_dms_document as td');
          $this->db->join('tbl_dms_document_details as tdd','td.version_id = tdd.id');
          //$this->db->where('tdd.root_id', $this->session->userdata('root_id'));
          $this->db->where('tdd.extension', '');
          $this->db->where('tdd.is_my_document ', 0 );
          $folderSubfolder = $this->db->get();
          $parentAndSubparentData = $folderSubfolder->result_array();
          $tree = $this->categoriesToTree($parentAndSubparentData);
          return $tree;
      
    }



    function getMyDocumentFolderData(){
        
        $this->db->select('*, tdd.name as docname');
        $this->db->from('tbl_dms_document as td');
        $this->db->join('tbl_dms_document_details as tdd','td.version_id = tdd.id');
       // $this->db->where('tdd.root_id', $this->session->userdata('root_id'));
        $this->db->where('tdd.is_my_document', 1);
        $this->db->where('tdd.extension', '');
        $folderSubfolder = $this->db->get();
       // echo $this->db->last_query();
        $parentAndSubparentData = $folderSubfolder->result_array();
        $tree = $this->categoriesToTree($parentAndSubparentData);
        return $tree;
    
  }


  function getCategoryFolderData(){
        
        $this->db->select('name,id,parent');
        $this->db->from('tbl_dms_categories as c');
        $folderSubfolder = $this->db->get();
        $parentAndSubparentData = $folderSubfolder->result_array();
        $tree = $this->categoriesToTree($parentAndSubparentData);
        return $tree;

    }



    function getMetadataFolderData(){

        $this->db->select('name,id,parent');
        $this->db->from('tbl_dms_metadata as c');
        $this->db->where('c.status',1);
        $folderSubfolder = $this->db->get();
        $parentAndSubparentData = $folderSubfolder->result_array();
        $tree = $this->categoriesToTree($parentAndSubparentData);
        return $tree;
   }




    function categoriesToTree(&$categories) {

            $map = array(
                0 => array('subcategories' => array())
            );

            foreach ($categories as &$category) {
                $category['subcategories'] = array();
                $map[$category['id']] = &$category;
            }

            foreach ($categories as &$category) {
                $map[$category['parent']]['subcategories'][] = &$category;
            }

            return $map[0]['subcategories'];

    }



//     function getParentDDLData(){
//           $this->db->select('tdd.id,tdd.name');
//           $this->db->from('tbl_dms_document as td');
//           $this->db->join('tbl_dms_document_details as tdd','td.version_id = tdd.id');
//           $this->db->where('tdd.root_id', $this->session->userdata('root_id'));
//           $this->db->where('tdd.extension', '');
//           $popUpDDQuery = $this->db->get();
//           $popUpDDQueryArray = $popUpDDQuery->result_array();
//           if($popUpDDQuery->num_rows() > 0)
//           return $popUpDDQueryArray;  
//    }



   function document_not_permitted_user_info($id){
         $query = $this->db->query("select user_id,username from tbl_users where user_id NOT IN (SELECT user_id FROM tbl_dms_permission where doc_id = ".$id.")");
         if($query->num_rows() > 0){
            return $query->result_array(); 
         }else{
           return false;
         }

   }



   /*function documentRelatedNoteAdded($noteArray){

            $data = [   'document_id' => $noteArray['document_id'],
                        'documnet_token' => $noteArray['note_token'],
                        'desc' => $noteArray['note'],
                        'created_on' => date('Y-m-d H:i:s')
                    ];
         
            $this->db->insert('tbl_dms_notes', $data); 
            if($this->db->affected_rows())
            return true;

   }



   function documentRelatedUpdated($noteArray){

        $data = array('desc'=>$noteArray['note'],'updated_on' => date('Y-m-d H:i:s'));
        $this->db->where('id',$noteArray['hidden_note_id']);
        $this->db->update('tbl_dms_notes',$data);
        if($this->db->affected_rows())
        return true;
        else
        return false;    

   }



   function getNoteListing($id){
       $noteListAuery = $this->db->get_where('tbl_dms_notes', ['document_id' => $id, 'status' => '1' ] );
       if($noteListAuery->num_rows() > 0)
       return $noteListAuery->result_array();
       else
       return false; 
   }*/



    /*function testByLbatra(){

          $this->db->select('name,id,parent');
          $query = $this->db->from('tbl_dms_document_details');
          if($query->num_rows() > 0){
                $dataArray = $query->result_array();
                $this->buildTreeBatra()
          } 


    } 





    function buildTreeBatra(Array $data, $parent = 0) {
        $tree = array();
        foreach ($data as $d) {
            if ($d['parent'] == $parent) {
                $children = buildTree($data, $d['id']);
                // set a trivial key
                if (!empty($children)) {
                    $d['_children'] = $children;
                }
                $tree[] = $d;
            }
        }
        return $tree;
    }*/


    /*function testByLbatra(){
          $this->db->select('*');
          $this->db->from('tbl_dms_document_details');
          $this->db->where('root_id', $this->session->userdata('root_id'));
          $this->db->where('parent', 0);
          $folderSubfolder = $this->db->get();
                $parentAndSubparentData = $folderSubfolder->result_array();
                $option = '';
                $option .= '<select>';
                foreach($parentAndSubparentData as $cat) {
                   $option .= "<option value=".$cat['id'].">".$cat['name'] . "</option>";
                   $this->sub_cat($cat['parent']);
                }
                $option .= '</select>';
                echo $option;
    }


    function sub_cat($cat_num){
          $option = '';
          $this->db->select('*');
          $this->db->from('tbl_dms_document');
          $this->db->where('root_id', $this->session->userdata('root_id'));
          $this->db->where('parent', $cat_num);
          $folderSubfolder1 = $this->db->get();
          foreach($folderSubfolder1->result_array() as $sub_cat_list){
                 $option .= '<option value="'.$sub_cat_list['id'].'>'.$sub_cat_list['name'].'</option>';
          }

    }*/


   /* function getParentFolderData($parent = 0 ,$level=0){
          $this->db->select('*');
          $this->db->from('tbl_dms_document');
          $this->db->where('root_id', $this->session->userdata('root_id'));
          $this->db->where('parent', $parent);
          $folderSubfolder = $this->db->get();
          $parentAndSubparentData = $folderSubfolder->result_array();
          $option = '';
          $option = '<select>';
          foreach($parentAndSubparentData as $cat) {
            $option .= "<option>". str_repeat("| - -  ".str_repeat('&nbsp;', $level), $level). $cat['name'] . "</option>";
            self::getParentFolderData($cat['parent'] ,$level+1);
          }
          $option .= '</select>';
          echo $option;

    } */


    /*function getParentFolderData(){
          $this->db->select('*');
          $this->db->from('tbl_dms_document');
          $this->db->where('root_id', $this->session->userdata('root_id'));
          $this->db->where('parent', 0);
          $folderSubfolder = $this->db->get();
          //if($folderSubfolder->num_rows() > 0){
                $parentAndSubparentData = $folderSubfolder->result_array();
                foreach($parentAndSubparentData as $value){
                            $this->db->select('*');
                            $this->db->from('tbl_dms_document');
                            $this->db->where('parent', $value['id']);
                            $folderSubfolderInner = $this->db->get();
                            //if($folderSubfolderInner->num_rows() > 0){
                                $dataOne = $folderSubfolderInner->result_array();
                                    foreach($dataOne as $valueone){
                                        $this->db->select('*');
                                        $this->db->from('tbl_dms_document');
                                        $this->db->where('parent', $valueone['id']);
                                        $folderSubfolderInnerOne = $this->db->get();
                                        //if($folderSubfolderInnerOne->num_rows() > 0){
                                            $dataTwo = $folderSubfolderInnerOne->result_array(); 
                                            foreach($dataTwo as $valuetwo){
                                                $this->db->select('*');
                                                $this->db->from('tbl_dms_document');
                                                $this->db->where('parent', $valuetwo['id']);
                                                $folderSubfolderInnerTwo = $this->db->get();
                                                //if($folderSubfolderInnerTwo->num_rows() > 0){
                                                    $dataThree = $folderSubfolderInnerTwo->result_array();
                                                    return array('LevelOne' => $parentAndSubparentData, 'LevelTwo' => $dataOne, 'LevelThree' => $dataTwo, 'LevelFour' => $dataThree ); 
                                               // }
                                            }
                                        //}
                                    } 
                            //}
                }
         // }
    }*/


    /*function getParentFolderData($parent = 0 ,$level=0) {
        $this->db->select('*');
        $this->db->from('tbl_dms_document');
        $this->db->where('root_id', $this->session->userdata('root_id'));
        $folderSubfolder = $this->db->get();
        if($folderSubfolder->num_rows() > 0){
                $parentAndSubparentData = $folderSubfolder->result_array();
        }
        
        foreach($parentAndSubparentData as $cat) {
            echo "<option>". str_repeat("| - -  ".str_repeat('&nbsp;', $level), $level). $cat['name'] . "</option>";
            $this->getParentFolderData($cat['id'] ,$level +1);
        }
 
    }*/


    



    // function buildtree($src_arr, $parent_id = 0, $tree = array()){
    //         foreach($src_arr as $idx => $row)
    //         {
    //             if($row['parent'] == $parent_id)
    //             {
    //                 foreach($row as $k => $v)
    //                     $tree[$row['id']][$k] = $v;
    //                     unset($src_arr[$idx]);
    //                     $tree[$row['id']]['children'] = $this->buildtree($src_arr, $row['id']);
    //             }
    //         }
    //         ksort($tree);
    //         return $tree;
    // }



    function getRealtedDocument($rid, $did, $sk){
        $query = $this->db->query("select original_name,id from tbl_dms_document_details where extension = '$sk' and id not in ( select doc_relation_id from tbl_dms_document_relations where relation_id = $rid and document_id = $did )");
        echo $this->db->last_query();
        if($query->num_rows() > 0){
                $option = '';
                foreach($query->result_array() as $row):
                  $option .= "<option value='".$row['id']."'>".$row['original_name']."</option>"; 
               endforeach;     
        }else{
            return $option = '';
        }
        return $option;
    }


    function getSearchDocument($data = array()){

        $sql = "SELECT * FROM tbl_dms_document_details as tddd WHERE tddd.status = 1 ";

		if (!empty($data['is_my_document'])) {
			$sql .= " AND tddd.is_my_document = ". $data['is_my_document'];
		}

		if (!empty($data['original_name'])) {
			$sql .= " AND tddd.original_name LIKE '%" . $data['original_name'] . "%'";
        }
        
        if (!empty($data['doc_title'])) {
			$sql .= " AND tddd.title LIKE '%" . $data['doc_title'] . "%'";
        }
        
        if (!empty($data['user_id'])) {
			$sql .= " AND tddd.updated_by = '" .$data['user_id']."'";
        }
        
		// if (isset($data['start']) || isset($data['limit'])) {
		// 	if ($data['start'] < 0) {
		// 		$data['start'] = 0;
		// 	}

		// 	if ($data['limit'] < 1) {
		// 		$data['limit'] = 20;
		// 	}
		// 	$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
        // }
        
//echo $sql;

        $query = $this->db->query($sql);
        if($query->num_rows() > 0){
            return $query->result_array(); 
        }else{
            return false;
        }

    }


    function getAdvancedSearchDocument($data = array()){

        $sql = "SELECT * FROM tbl_dms_document_details as tddd";


        if (!empty($data['category'])) {
            $sql .= " LEFT JOIN tbl_dms_document_categories as tddc ON (tddc.document_id = tddd.id)";
        }


        $sql .= " WHERE tddd.status = 1 ";


        if (!empty($data['path'])) {
              $this->db->select('id');
              $pathQuery = $this->db->get_where('tbl_dms_document_details',['path' => $data['path']]);
              if($pathQuery->num_rows() > 0){
                  $sql .= " AND tddd.is_my_document = 0 AND tddd.parent = '". $pathQuery->row_array()['id']."'";
              }else{
                  $sql .= '';
              } 
			
		}

        if( !empty($data['type'][0]) && !empty($data['type'][1])){
            $sql .= " AND (tddd.extension != '' OR tddd.extension = '') ";
        }elseif(!empty($data['type'][0]) && $data['type'][0] == 1){
            $sql .= " AND tddd.extension != '' ";
        }elseif(!empty($data['type'][1]) &&  $data['type'][1] == 2){
            $sql .= " AND tddd.extension ='' ";
        }else{
            $sql .= " AND tddd.extension ='' ";
        }
        
        if (!empty($data['extension'])) {
			$sql .= " AND tddd.extension = '" . $data['extension'] . "'";
        }


        if (!empty($data['category'])) {
              $this->db->select('id');
              $pathQuery = $this->db->get_where('tbl_dms_categories',['name' => $data['category']]);
              if($pathQuery->num_rows() > 0){
                  $sql .= " AND tddc.category_id = '". $pathQuery->row_array()['id']."'";
              }else{
                  $sql .= '';
              } 
            
        }


        $query = $this->db->query($sql);
        if($query->num_rows() > 0){
            return $query->result_array(); 
        }else{
            return false;
        }

    }


    function getSearchPath($did){
        $this->db->select('path');
        $pathQuery = $this->db->get_where('tbl_dms_document_details', ['id' => $did]);
        if($pathQuery->num_rows() > 0){
           $path = $pathQuery->row_array()['path'];
           return $path;
        }else{
            return '/okm:root';
        }
    }


    function getSearchCatgory($cid){
        $this->db->select('name');
        $pathQuery = $this->db->get_where('tbl_dms_categories', ['id' => $cid]);
        if($pathQuery->num_rows() > 0){
           $path = $pathQuery->row_array()['name'];
           return $path;
        }else{
            return '/okm:categories';
        }   
    }


    function getCategotyDocumentListing($cid){
        $this->db->select('dd.root_id,dd.id as id,dd.name as name,dd.updated_on,dd.original_name,dd.title,dd.version,dd.size,dd.language,dd.extension,dd.mime_type');
        $this->db->from('tbl_dms_document_categories as dc');
        $this->db->join('tbl_dms_document_details as dd', 'dc.document_id = dd.id');
        $this->db->join('tbl_dms_categories as c', 'dc.category_id = c.id');
        $this->db->where('c.id' , $cid);
        $this->db->where('c.status' , 1);
        $queryCat = $this->db->get();
        if($queryCat->num_rows() > 0){
            return $queryCat->result_array();
        }else{
            return false;
        }
    }



    function update_view_count($id){
        $this->db->set('view_count', 'view_count+1', FALSE);
        $this->db->where('id', $id);
        $this->db->update('tbl_dms_document_details');
        if($this->db->affected_rows() > 0){
            return true;
        }else{
            die('Invalid Id');
        }
    }

    function update_modify_count($id){
            $this->db->set('modify_count', 'modify_count+1', FALSE);
            $this->db->where('id', $id);
            $this->db->update('tbl_dms_document_details');
            if($this->db->affected_rows() > 0){
                return true;
            }else{
                die('Invalid Id');
            }
    }


    function getSubMetaGroupName($mid){
        $sub_meta_array = $this->db->select('name,id')->get_where('tbl_dms_metadata_subgroup',['metadata_id' => $mid])->result_array();
        if($sub_meta_array){
            $HTML = '';
            foreach($sub_meta_array as $value){
                 $HTML .= "<option value=".$value['id'].">".$value['name']."</option>";
            }
            return $HTML; 
        }

    }

} ?>
