<?php

class Logistics_Model extends MY_Model
{

    public $_table_name;
    public $_order_by;
    public $_primary_key;

     function updated_task($id)
    {
       // print_r($id); exit();
        $my_accept = array('logistics_task_accept'=>'yes');
        $this->db->where('task_id', $id);
        $this->db->update('tbl_logistics_task',$my_accept);

    }

     function get_user_name($user_id)
    {
       // print_r($id); exit();
       return $this->db->select('username')->from('tbl_users')->where('user_id',$user_id)->get()->result();

    }
   
    function get_accept_task($id)
    {
        return $this->db->select('*')->from('tbl_logistics_trnsport_task_details')->where('task_id',$id)->get()->result();

    }
    function insert_task($postData)
    {
        $inserted = $this->db->insert('tbl_logistics_trnsport_task_details',$postData);
         if($inserted) {
                return $this->db->insert_id();
            }

           else{
        return false;
         }

    }

    function set_progress($id)
    {
        $project_info = $this->check_by(array('project_id' => $id), 'tbl_project');
        if ($project_info->calculate_progress != '0') {
            if ($project_info->calculate_progress == 'through_tasks') {
                $done_task = count($this->db->where(array('project_id' => $id, 'task_status' => 'completed'))->get('tbl_logistics_task')->result());
                $total_tasks = count($this->db->where(array('project_id' => $id))->get('tbl_logistics_task')->result());
                $progress = round(($done_task / $total_tasks) * 100);
                if ($progress > 100) {
                    $progress = 100;
                }
            }
        } else {
            $progress = $project_info->progress;
        }
        if (empty($progress)) {
            $progress = 0;
        }
        $p_data = array(
            'progress' => $progress,
        );

        $this->_table_name = "tbl_project"; //table name
        $this->_primary_key = "project_id";
        $this->save($p_data, $id);
        return true;
    }

    public function get_statuses()
    {
        $statuses = array(
            array(
                'id' => 1,
                'value' => 'not_started',
                'name' => lang('not_started'),
                'order' => 1,
            ),
            array(
                'id' => 2,
                'value' => 'in_progress',
                'name' => lang('in_progress'),
                'order' => 2,
            ),
            array(
                'id' => 3,
                'value' => 'completed',
                'name' => lang('completed'),
                'order' => 3,
            ),
            array(
                'id' => 4,
                'value' => 'deferred',
                'name' => lang('deferred'),
                'order' => 4,
            ),
            array(
                'id' => 5,
                'value' => 'waiting_for_someone',
                'name' => lang('waiting_for_someone'),
                'order' => 5,
            )
        );
        return $statuses;
    }

    public function get_assign_user($id)
    {
        return $this->db->select('permission')->from('tbl_logistics_task')->where('task_id',$id)->get()->result_array();
    }
    public function insert_assign_user_permission($id,$insert_assign_user)
    {
        
        $permission = $insert_assign_user[0]['permission'];
        
       
        $data = array('project_id'=>$id,'first_user'=>$permission);
        
        $this->db->insert('assig_user', $data);
    }
    public function update_assignment_flow($task_id,$task_permission,$assigned_by)
    {
        $data = array('second_user'=>$task_permission,'assigned_by'=>$assigned_by);
        $this->db->where('task_id',$task_id);
        $this->db->update('assig_user',$data);
    }
    // public function create_assignment_flow($task_id,$task_name,$task_permission)
    // {
    //     $data = array('task_id'=>$task_id,'task_name'=>$task_name,'first_user'=>$task_permission);
    //     $this->db->insert('assig_user', $data);
    // }
    public function get_department_name()
    {
        return $this->db->select('*')->from('sub_department')->get()->result_array();
    }
    public function get_allowed_user_new($menu_id,$desig)
    {
        $permission_user = $this->all_permission_user_new($menu_id,$desig);
        // get all admin user
        $admin_user = $this->db->where('role_id', 1)->get('tbl_users')->result();
        // if not exist data show empty array.
        if (!empty($permission_user)) {
            $permission_user = $permission_user;
        } else {
            $permission_user = array();
        }
        if (!empty($admin_user)) {
            $admin_user = $admin_user;
        } else {
            $admin_user = array();
        }
        $result = array_merge($admin_user, $permission_user);
        return $result;
    }

    public function all_permission_user_new($menu_id,$desig)
    {
        $this->db->select('tbl_user_role.designations_id', FALSE);
        $this->db->select('tbl_account_details.designations_id', FALSE);
        $this->db->select('tbl_users.*', FALSE);
        $this->db->from('tbl_user_role');
        $this->db->join('tbl_account_details', 'tbl_account_details.designations_id = tbl_user_role.designations_id', 'left');
        $this->db->join('tbl_users', 'tbl_users.user_id = tbl_account_details.user_id', 'left');
        $this->db->where('tbl_user_role.menu_id', $menu_id);
        $this->db->where('tbl_account_details.department_id', $desig);
        $this->db->where('tbl_users.activated', 1);
        $query_result = $this->db->get();
        $result = $query_result->result();
        return $result;
    }

    public function get_department_name_by_id($id)
    {

        return $this->db->select('*')->from('tbl_account_details')->where('designations_id',$id)->get()->result_array();
    
    }
    public function get_sub_cat($id)
    {
        
        return $this->db->select('*')->from('tbl_departments')->where('parent_id',$id)->get()->result_array();

    }
    public function get_userdepartment($id)
    {
        return $this->db->select('*')->from('tbl_account_details')->where('departments_id',$id)->get()->result_array();
    }
    public function get_user_info($id)
    {
        return $this->db->select('*')->from('tbl_account_details')->where('designations_id',$id)->get()->result_array();
    }
    public function get_allowed_user_new1($menu_id,$id)
    {   
        $permission_user = $this->all_permission_user_new1($menu_id,$id);
        // get all admin user
        $admin_user = $this->db->where('role_id', 1)->get('tbl_users')->result();
        // if not exist data show empty array.
        if (!empty($permission_user)) {
            $permission_user = $permission_user;
        } else {
            $permission_user = array();
        }
        if (!empty($admin_user)) {
            $admin_user = $admin_user;
        } else {
            $admin_user = array();
        }
        $result = array_merge($admin_user, $permission_user);
        return $result;
    }

    public function all_permission_user_new1($menu_id,$id)
    {
        $this->db->select('tbl_user_role.designations_id', FALSE);
        $this->db->select('tbl_account_details.designations_id', FALSE);
        $this->db->select('tbl_users.*', FALSE);
        $this->db->from('tbl_user_role');
        $this->db->join('tbl_account_details', 'tbl_account_details.designations_id = tbl_user_role.designations_id', 'left');
        $this->db->join('tbl_users', 'tbl_users.user_id = tbl_account_details.user_id', 'left');
        $this->db->where('tbl_user_role.menu_id', $menu_id);
        $this->db->where('tbl_account_details.parent_id', $id);
        $this->db->where('tbl_users.activated', 1);
        $query_result = $this->db->get();
        $result = $query_result->result();
        return $result;
    }

    public function get_all_main_cat()
    {
        return $this->db->select('*')->from('sub_department')->get()->result_array();
    }
    public function get_all_main_cat_user()
    {
        return $this->db->select('*')->from('tbl_account_details')->get()->result_array();
    }

    public function get_all_main_cat_dept()
    {
       
        $dept_data = $this->db->select('*')->from('tbl_departments')->get()->result_array();
        // foreach ($data as $key => $value) {
        //  $id = $value['departments_id'];
        //  $dept_name[] = $value['deptname'];
        
       //  }

         return $dept_data;
        // exit; 
         //return $this->db->select('*')->from('tbl_account_details')->get()->result_array();
    }
    public function get_all_main_cat_user1()
    {
         return $this->db->select('*')->from('tbl_account_details')->get()->result_array();
    }
    // public function get_permission_main_cat($main_cat)
    // {
    //     return $this->db->select("*")->from('tbl_logistics_task')->where('parent_id',$main_cat)->get()->result_array();
    // }
    public function get_permission_main_cat($main_cat,$table)
    {

        
        //$role = $this->session->userdata('user_type');
         $user_id = $main_cat;
       
            $result_info = $this->db->get($table)->result();
         
            if (!empty($result_info)) {
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        $permission[] = $result;
                    } else {
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) {
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
      else {

            
            $permission = $this->db->where('parent_id',$main_cat)->get($table)->result();

        }
        if (empty($permission)) {
            $permission = array();
        }
        return $permission;
    }

    public function get_permission_main_cat_user($main_cat_user,$table,$status)
    {
       
    // $table = 'tbl_logistics_task';
   // $role = $user_role_id;
        if($status!='')
        {
            $this->db->where('opportunities_state_reason_id',$status);
        }

        if($main_cat_user!='')
        {
        $user_id = $main_cat_user;
        }
        else
        {

            $user_id = $this->session->userdata('user_id');

        }
        
                
       
            $result_info = $this->db->get($table)->result();
           
            // if (!empty($result_info)) {
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        $permission[] = $result;
                    } else {
                       
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) {
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            // }
        //  else {

              
                
        //     $permission = $this->db->get($table)->result();

        // }

       
        // if (empty($permission)) 
        // {
        //     $permission = array();
        // }
        return $permission;
    }


     public function get_permission_main_cat_user_search($main_cat_user,$user_role_id,$id)
    {
     $table = 'tbl_logistics_task';
    $role = $user_role_id;
        $user_id = $main_cat_user;
        
        if ($role != 1) {
            $result_info = $this->db->where('task_status',$id)->get($table)->result();
           
            if (!empty($result_info)) {
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        $permission[] = $result;
                    } else {
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) {
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
        } else {

            
            $permission = $this->db->where('task_status',$id)->get($table)->result();

        }
        if (empty($permission)) {
            $permission = array();
        }
        return $permission;
    }


    public function get_permission_main_cat_user_filter($filter)
    {
        
      if($filter=='self')
      {
        $user_id = $this->session->userdata('user_id');
        return $this->db->select("*")->from('tbl_logistics_task')->where('created_by',$user_id)->get()->result_array();
        
      }  

    }



    public function get_role_id($main_cat_user)
    {
        return $this->db->select('role_id')->from('tbl_users')->where('user_id',$main_cat_user)->get()->row_array();
    }

    public function get_sub_cat_search($id)
    {
        return $this->db->select('*')->from('tbl_account_details')->where('parent_id',$id)->get()->result_array();
    }

    // public function get_permission_main_cat_for_task($main_cat,$id)
    // {
    //     die("hello");
    //     $table = 'tbl_logistics_task';
    // $role = $this->session->userdata('user_type');
    //     $user_id = $this->session->userdata('user_id');

    //     if ($role != 1) {

    //         $result_info = $this->db->get($table)->result();
         
    //         if (!empty($result_info)) {
    //             foreach ($result_info as $result) {
    //                 if ($result->permission == 'all') {
    //                     $permission[] = $result;
    //                 } else {
    //                     $get_permission = json_decode($result->permission);
    //                     if (is_object($get_permission)) {
    //                         foreach ($get_permission as $id => $v_permission) {
    //                             if ($user_id == $id) {
    //                                 $permission[] = $result;
    //                             }
    //                         }
    //                     }
    //                 }
    //             }
    //         }
    //     } else {


    //         $permission = $this->db->where('parent_id',$main_cat)->where('task_status',$id)->get($table)->result();



    //     }
    //     if (empty($permission)) {
    //         $permission = array();
    //     }
    //     return $permission;
    // }


public function get_allowed_user_new2($menu_id,$id)
{

        $this->db->select('tbl_user_role.designations_id', FALSE);
        $this->db->select('tbl_account_details.designations_id', FALSE);
        $this->db->select('tbl_users.*', FALSE);
        $this->db->from('tbl_user_role');
        $this->db->join('tbl_account_details', 'tbl_account_details.designations_id = tbl_user_role.designations_id', 'left');
        $this->db->join('tbl_users', 'tbl_users.user_id = tbl_account_details.user_id', 'left');
        $this->db->where('tbl_user_role.menu_id', $menu_id);
       // $this->db->where('tbl_account_details.parent_id', $parent_id);
       
            //$this->db->where('tbl_account_details.department_id', $sub_cat);
      
        $this->db->where('tbl_users.activated', 1);
        $this->db->like('tbl_users.username', $id);
        $query_result = $this->db->get();
        $result = $query_result->result();
        return $result;
}
public function get_allowed_user_new3($menu_id,$id,$parent_id)
{

        $this->db->select('tbl_user_role.designations_id', FALSE);
        $this->db->select('tbl_account_details.designations_id', FALSE);
        $this->db->select('tbl_users.*', FALSE);
        $this->db->from('tbl_user_role');
        $this->db->join('tbl_account_details', 'tbl_account_details.designations_id = tbl_user_role.designations_id', 'left');
        $this->db->join('tbl_users', 'tbl_users.user_id = tbl_account_details.user_id', 'left');
        $this->db->where('tbl_user_role.menu_id', $menu_id);
        $this->db->where('tbl_account_details.parent_id', $parent_id);
        
        $this->db->where('tbl_users.activated', 1);
        $this->db->like('tbl_users.username', $id);
        $query_result = $this->db->get();
        $result = $query_result->result();
        return $result;
}

public function get_allowed_user($menu_id)
{
    $data['created_by'] = $this->session->userdata('user_id');
    $this->db->select('tbl_user_role.designations_id', FALSE);
        $this->db->select('tbl_account_details.designations_id', FALSE);
        $this->db->select('tbl_users.*', FALSE);
        $this->db->from('tbl_user_role');
        $this->db->join('tbl_account_details', 'tbl_account_details.designations_id = tbl_user_role.designations_id', 'left');
        $this->db->join('tbl_users', 'tbl_users.user_id = tbl_account_details.user_id', 'left');
        $this->db->where('tbl_user_role.menu_id', $menu_id);
        $this->db->where('tbl_account_details.parent_id', $id);
        $this->db->where('tbl_users.activated', 1);

        $query_result = $this->db->get();
        $result = $query_result->result();
        return $result;

}
public function get_permission_own_model($table, $flag = null)
    {
         
        $table = 'tbl_logistics_task';
        $role = $this->session->userdata('user_type');
        $user_id = $this->session->userdata('user_id');


        if ($role != 1) {

            $result_info = $this->db->get($table)->result();
         
            if (!empty($result_info)) {
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        $permission[] = $result;
                    } else {
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) {
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
        } 
        else 
        {

             if($user_id==83)
            {

                $result_info = $this->db->get($table)->result();
                $user_list = $this->db->select('user_id')->from('tbl_users')->where('manager',$user_id)->get()->result_array();
                $final_result = array();
                foreach ($user_list as $key ) 
                {
                   $final_result[] = $key['user_id'];
                }
                

                if (!empty($result_info)) {
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        $permission[] = $result;
                    } else {
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) {
                            foreach ($get_permission as $id => $v_permission) {
                                if (in_array($id, $final_result)) {
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
        }

        else
        {
            $permission = $this->db->get($table)->result();
        }
    }
            
            



        if (empty($permission)) {
            $permission = array();
        }

        return $permission;
    }
    public function get_project($id)
    {
        return $this->db->select('project_name')->from('tbl_project')->get()->row_array();
    }
    public function  get_valid_user_through_main_cat($main_cat)
    {
        return $this->db->select('user_id')->from('tbl_account_details')->where('parent_id',$main_cat)->get()->result_array();
    }
    public function get_admin_users()
    {
        
        // get all admin user
        $this->db->select('GROUP_CONCAT(tbl_users.user_id) as uid');
        $admin_user = $this->db->where('role_id', 1)->get('tbl_users')->row()->uid;
        // if not exist data show empty array.

        if (!empty($admin_user)) {
            $admin_user = $admin_user;
        } else {
            $admin_user = "";
        }

        return $admin_user;
    }

    public function get_user_task_only($user_id)
    {
        
        $result_info = $this->db->where('task_status','in_progress')->get('tbl_logistics_task')->result();
            if (!empty($result_info)) {
                
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        
                        $permission[] = $result;
                    } else {
                       
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) { 
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                   
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
      
        if (empty($permission)) 
        {
            $permission = array();
        }
        return $permission;
    }

    public function get_user_project_only($user_id)
    {
        $result_info = $this->db->where('project_status','in_progress')->get('tbl_project')->result();
            if (!empty($result_info)) {
                
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        
                        $permission[] = $result;
                    } else {
                       
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) { 
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                   
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
      
        if (empty($permission)) 
        {
            $permission = array();
        }
        return $permission;
    }
    public function get_user_bug_only($user_id)
    {
        $result_info = $this->db->where('bug_status','in_progress')->get('tbl_bug')->result();
            if (!empty($result_info)) {
                
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        
                        $permission[] = $result;
                    } else {
                       
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) { 
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                   
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
      
        if (empty($permission)) 
        {
            $permission = array();
        }
        return $permission;
    }
    public function get_user_ticket_only($user_id)
    {
        $result_info = $this->db->where('status','in_progress')->get('tbl_tickets')->result();
            if (!empty($result_info)) {
                
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        
                        $permission[] = $result;
                    } else {
                       
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) { 
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                   
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
      
        if (empty($permission)) 
        {
            $permission = array();
        }
        return $permission;
    }

    public function get_user_opprotunities_only($user_id,$date)
   {

        if($date !="" )
        $this->db->where('next_action_date',$date);
        
        
        $result_info = $this->db->get('tbl_opportunities')->result();
            if (!empty($result_info)) {
                
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        
                        $permission[] = $result;
                    } else {
                       
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) { 
                            foreach ($get_permission as $id => $v_permission) {
                                if ($user_id == $id) {
                                   
                                    $permission[] = $result;
                                }
                            }
                        }
                    }
                }
            }
      
        if (empty($permission)) 
        {
            $permission = array();
        }
        return $permission;
    }

    // public function get_user_mail_only($email)
    // {
    //     return $this->db->select('*')->from('tbl_inbox')->where('view_status','2')->where('to',$email)->get()->result_array();
    // }

    // public function get_user_stock_only($user_id)
    // {
    //     return $this->db->select('*')->from('tbl_assign_item')->where('user_id',$user_id)->get()->result_array();
    // }

    public function get_client_list()
    {
        return $this->db->select('*')->from('tbl_client')->get()->result_array();
    }
    public function get_status_count($table, $userid,$task_id="",$status,$priority,$search_task)
    {
        $roleid=$this->db->get_where('tbl_users',array('user_id'=>$userid))->row();
        $role = $roleid->role_id;
        if($status !="" )

        $this->db->where('task_status',$status);
         if($priority !="" )
        $this->db->where('priority',$priority);

        if($search_task!="")
            $this->db->like('task_name',$search_task);

        if($task_id !="")
        $this->db->where('task_id',$task_id);


        $this->db->order_by('task_id','desc');
        $this->db->select('task_id,task_name,task_start_date,due_date,task_progress,task_status,permission,task_description,created_by,task_created_date,project_id,milestones_id,opportunities_id,goal_tracking_id,leads_id,bug_id');
        if ($role != 1) {
            $result_info = $this->db->get($table)->result();
            if (!empty($result_info)) {
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        $permission[] = $result;
                    } else {
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) {
                            foreach ($get_permission as $id => $v_permission) {
                                if ($userid == $id) {
                                    $permission[] = $result;
                                }
                                
                            }
                            
                            
                        }
                    }
                }
            }
        } else {
            $permission = $this->db->get($table)->result();
        }
        if (empty($permission)) {
            $permission = array();
        }
        return $permission;
    }
    
    public function get_opportunities_for_status($status)
    {
        
        return $this->db->select('*')->from('tbl_opportunities')->where('opportunities_state_reason_id',$status)->get()->result_array();
    }

    public function assign_task_get_only($table,$userid)
    {

        $roleid=$this->db->get_where('tbl_users',array('user_id'=>$userid))->row();
        $role = $roleid->role_id;
        
        if ($role != 1) {
            $result_info = $this->db->where("created_by !=",$userid)->get($table)->result();
            if (!empty($result_info)) {
                foreach ($result_info as $result) {
                    if ($result->permission == 'all') {
                        $permission[] = $result;
                    } else {
                        $get_permission = json_decode($result->permission);
                        if (is_object($get_permission)) {
                            foreach ($get_permission as $id => $v_permission) {
                                if ($userid == $id) {
                                    $permission[] = $result;
                                }
                                
                            }
                            
                            
                        }
                    }
                }
            }
        } else {
            $permission = $this->db->get($table)->result();
        }
        if (empty($permission)) {
            $permission = array();
        }
        
        return $permission;
    }

}
